local addonName, addon = ...

local panel = CreateFrame("FRAME")
local playerName = UnitName("player");
panel.name = addonName
panel:Hide()

panel:SetScript("OnShow", function(panel)

local title = panel:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
title:SetPoint("TOPLEFT", 16, -16)
title:SetText(addonName.." "..ARP_VERSION)


local MinimapCheckBox = CreateFrame("CheckButton", "MinimapCheckBox", panel, "UICheckButtonTemplate");
MinimapCheckBox:SetPoint("TOPLEFT", title, 0, -40);
MinimapCheckBox:SetSize(30, 30);
MinimapCheckBox:SetNormalFontObject("GameFontNormalLarge");
MinimapCheckBox:SetHighlightFontObject("GameFontHighlightLarge");

if AchchazusRaidplanerDBminimap.hide == false then
		MinimapCheckBox:SetChecked(false)
else
		MinimapCheckBox:SetChecked(true)
end

MinimapCheckBox:SetScript("OnClick", function(self, value)              

PlaySound(855)

if AchchazusRaidplanerDBminimap.hide == true then
	LibStub("LibDBIcon-1.0"):Show(addonName)
	AchchazusRaidplanerDBminimap.hide = false
	return
else
	LibStub("LibDBIcon-1.0"):Hide(addonName)
	AchchazusRaidplanerDBminimap.hide = true
	return
end

end )

local MinimapCheckBoxText = panel:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
MinimapCheckBoxText:SetPoint("LEFT", MinimapCheckBox, 35, 0);
MinimapCheckBoxText:SetText(ARP_MINIMAPBUTTON)

local ShamanCheckBox = CreateFrame("CheckButton", "ShamanCheckBox", panel, "UICheckButtonTemplate");
ShamanCheckBox:SetPoint("TOPLEFT", MinimapCheckBox, 0, -40);
ShamanCheckBox:SetSize(30, 30);
ShamanCheckBox:SetNormalFontObject("GameFontNormalLarge");
ShamanCheckBox:SetHighlightFontObject("GameFontHighlightLarge");

if AchchazusRaidplanerDBlocal.ShamanColor == false then
		ShamanCheckBox:SetChecked(false)
else
		ShamanCheckBox:SetChecked(true)
end

ShamanCheckBox:SetScript("OnClick", function(self, value)              

PlaySound(855)

if AchchazusRaidplanerDBlocal.ShamanColor == true then
    AchchazusRaidplanerDBlocal.ShamanColorR = 0.96
	AchchazusRaidplanerDBlocal.ShamanColorG = 0.55
	AchchazusRaidplanerDBlocal.ShamanColorB = 0.73
	AchchazusRaidplanerDBclass["cS"]["r"] = 0.96
	AchchazusRaidplanerDBclass["cS"]["g"] = 0.55
	AchchazusRaidplanerDBclass["cS"]["b"] = 0.73
	AchchazusRaidplanerDBlocal.ShamanColor = false
	return
else
	AchchazusRaidplanerDBlocal.ShamanColorR = 0
	AchchazusRaidplanerDBlocal.ShamanColorG = 0.44
	AchchazusRaidplanerDBlocal.ShamanColorB = 0.87
	AchchazusRaidplanerDBclass["cS"]["r"] = 0
	AchchazusRaidplanerDBclass["cS"]["g"] = 0.44
	AchchazusRaidplanerDBclass["cS"]["b"] = 0.87
	AchchazusRaidplanerDBlocal.ShamanColor = true
	return
end

end )

local ShamanCheckBoxText = panel:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
ShamanCheckBoxText:SetPoint("LEFT", ShamanCheckBox, 35, 0);
ShamanCheckBoxText:SetText(ARP_SHAMANCOLOR)

local ColorCheckBox = CreateFrame("FRAME",nil, panel, "OptionsBoxTemplate")

ColorCheckBox:SetSize(150, 30);
ColorCheckBox:SetPoint("LEFT", ShamanCheckBox, 0, -50)

ColorCheckBox.text = ColorCheckBox:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
ColorCheckBox.text:SetPoint("CENTER", ColorCheckBox, "CENTER", 0, 0);
ColorCheckBox.text:SetTextColor(AchchazusRaidplanerDBlocal.ApprovedColorR, AchchazusRaidplanerDBlocal.ApprovedColorG, AchchazusRaidplanerDBlocal.ApprovedColorB)
ColorCheckBox.text:SetText(ARP_COLORDUMMY)

ColorCheckBox:EnableMouse(true)
  
ColorCheckBox:SetScript("OnMouseDown", function(self,button,...)

function ShowColorPicker(r, g, b, a, changedCallback)
 ColorPickerFrame:SetColorRGB(AchchazusRaidplanerDBlocal.ApprovedColorR,AchchazusRaidplanerDBlocal.ApprovedColorG,AchchazusRaidplanerDBlocal.ApprovedColorB);
 ColorPickerFrame.hasOpacity, ColorPickerFrame.opacity = (AchchazusRaidplanerDBlocal.ApprovedColorA ~= nil), AchchazusRaidplanerDBlocal.ApprovedColorA;
 ColorPickerFrame.previousValues = {AchchazusRaidplanerDBlocal.ApprovedColorR,AchchazusRaidplanerDBlocal.ApprovedColorG,AchchazusRaidplanerDBlocal.ApprovedColorB,AchchazusRaidplanerDBlocal.ApprovedColorA};
 ColorPickerFrame.func = changedCallback
 ColorPickerFrame.opacityFunc = changedCallback
 ColorPickerFrame.cancelFunc = changedCallback
 ColorPickerFrame:Hide();
 ColorPickerFrame:Show();
end

local function myColorCallback(restore)
 local newR, newG, newB, newA;
 if restore then
  newR, newG, newB, newA = unpack(restore);
 else

  newA, newR, newG, newB = OpacitySliderFrame:GetValue(), ColorPickerFrame:GetColorRGB();
 end
 
 AchchazusRaidplanerDBlocal.ApprovedColorR, AchchazusRaidplanerDBlocal.ApprovedColorG, AchchazusRaidplanerDBlocal.ApprovedColorB, AchchazusRaidplanerDBlocal.ApprovedColorA = newR, newG, newB, newA;
 ColorCheckBox.text:SetTextColor(AchchazusRaidplanerDBlocal.ApprovedColorR, AchchazusRaidplanerDBlocal.ApprovedColorG, AchchazusRaidplanerDBlocal.ApprovedColorB)
end

if button == "LeftButton" then
    ShowColorPicker(r, g, b, a, myColorCallback);
end

end )

local ColorCheckBoxText = panel:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
ColorCheckBoxText:SetPoint("RIGHT", ColorCheckBox, 175, 0);
ColorCheckBoxText:SetText(ARP_COLORCHOOSEAPPROVED)

guildName, guildRankName, guildRankIndex = GetGuildInfo("player");

if tonumber(guildRankIndex) <=  1 then   -- <= 

local GuildLeaderMenu = panel:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
GuildLeaderMenu:SetPoint("LEFT", title, 0, -200);
GuildLeaderMenu:SetText(ARP_SYNCRO)

local GuildLeaderMenu2 = panel:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
GuildLeaderMenu2:SetPoint("LEFT", GuildLeaderMenu, 0, -15);
GuildLeaderMenu2:SetText(ARP_WARNING)

SyncroButton = CreateFrame("Button", nil, panel, "GameMenuButtonTemplate");
SyncroButton:SetPoint("LEFT", GuildLeaderMenu2, 150, -50);
SyncroButton:SetSize(200, 30);
SyncroButton:SetNormalFontObject("GameFontNormalLarge");
SyncroButton:SetHighlightFontObject("GameFontHighlightLarge");
SyncroButton:SetText(ARP_STARTSYNCRO)
SyncroButton:SetScript("OnClick", function()	

StaticPopup_Show ("CONFORM_SEND")

end )

local GuildLeaderMenu3 = panel:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
GuildLeaderMenu3:SetPoint("CENTER", SyncroButton, 0, -35);

local RaidEntrysBackup = 0

for key in pairs(AchchazusRaidplanerDBbackup) do
RaidEntrysBackup = RaidEntrysBackup + 1
end

local RaidEntrys = 0

for key in pairs(AchchazusRaidplanerDB) do
RaidEntrys = RaidEntrys + 1
end

if RaidEntrysBackup > RaidEntrys then
GuildLeaderMenu3:SetText("Last Data: "..AchchazusRaidplanerDBbackup[RaidEntrysBackup])
end

local CheckButton = CreateFrame("Button", nil, panel, "GameMenuButtonTemplate");
CheckButton:SetPoint("CENTER", GuildLeaderMenu3, 0, -50);
CheckButton:SetSize(350, 30);
CheckButton:SetNormalFontObject("GameFontNormalLarge");
CheckButton:SetHighlightFontObject("GameFontHighlightLarge");
CheckButton:SetText(ARP_CHECK)
CheckButton:SetScript("OnClick", function()	

AchchazusRaidplanerDBlocal.CheckData = true

ARP_Globals.DataUpgrade()

end )

CheckButtonBoxText = panel:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
CheckButtonBoxText:SetPoint("Center", CheckButton, 0, -35);
CheckButtonBoxText:SetText(ARP_CHECKBOXTEXT)

SendButton = CreateFrame("Button", nil, panel, "GameMenuButtonTemplate");
SendButton:SetPoint("CENTER", CheckButtonBoxText, 0, -50);
SendButton:SetSize(350, 30);
SendButton:SetNormalFontObject("GameFontNormalLarge");
SendButton:SetHighlightFontObject("GameFontHighlightLarge");
SendButton:SetText(ARP_NODATA)
SendButton:Disable()
SendButton:SetScript("OnClick", function()	

anfang, ende = string.find(AchchazusRaidplanerDBlocal.transfer, " = ")

text = tostring(AchchazusRaidplanerDBlocal.transfer)

AchchazusRaidplanerDBlocal.datasender = string.sub(text, math.floor(ende + 1))
datadate = string.sub(text, 1, anfang)

StaticPopup_Show ("CONFORM_SYNC")

end )


end

panel:SetScript("OnShow", nil)

end )

function ARP_Globals.UpgradeText()
	CheckButtonBoxText:SetText(tostring(AchchazusRaidplanerDBlocal.transfer))
	SendButton:SetText(ARP_YESDATA)
	SendButton:Enable()
	return
end

StaticPopupDialogs["CONFORM_SYNC"] = {
  text = ARP_STARTSYNCRO.."\n"..ARP_WARNING,
  button1 = ARP_YES,
  button2 = ARP_NO,
  OnAccept = function()
      SendSyncroToPlayer()
  end,
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
  preferredIndex = 3, 
}

StaticPopupDialogs["CONFORM_SEND"] = {
  text = ARP_STARTSYNCRO.."\n"..ARP_WARNING,
  button1 = ARP_YES,
  button2 = ARP_NO,
  OnAccept = function()
      SendSyncro()
  end,
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
  preferredIndex = 3, 
}

function SendSyncroToPlayer()

datasender = AchchazusRaidplanerDBlocal.datasender

ARP_Globals.DataSender(datasender)

end

function SendSyncro()

AchchazusRaidplanerDBlocal.GetData = false
AchchazusRaidplanerDBlocal.UpdateDate = true

local RaidEntrysBackup = 0

for key in pairs(AchchazusRaidplanerDBbackup) do
RaidEntrysBackup = RaidEntrysBackup + 1
end

local RaidEntrysBackup = 0

for key in pairs(AchchazusRaidplanerDBbackup) do
RaidEntrysBackup = RaidEntrysBackup + 1
end

local RaidEntrys = 0

for key in pairs(AchchazusRaidplanerDB) do
RaidEntrys = RaidEntrys + 1
end

if RaidEntrys < RaidEntrysBackup then
 table.remove(AchchazusRaidplanerDBbackup, RaidEntrysBackup)
end

local LibDeflate = LibStub:GetLibrary ("LibDeflate")
local LibAceSerializer = LibStub:GetLibrary ("AceSerializer-3.0")
	
	if (LibDeflate and LibAceSerializer) then
		local dataSerialized = LibAceSerializer:Serialize (AchchazusRaidplanerDBbackup)
		if (dataSerialized) then
			local dataCompressed = LibDeflate:CompressDeflate (dataSerialized, {level = 9})
			if (dataCompressed) then
					local dataEncoded = LibDeflate:EncodeForPrint (dataCompressed)
					local dataEncodedChat = LibDeflate:EncodeForWoWAddonChannel (dataCompressed)		
					
					 SendChatMessage("Spieler: "..playerName.." hat gerade die Syncronisation gestartet" ,"GUILD")
					 ARP_Globals.SendUpdate(dataEncodedChat)
			end
		end
	end

end

InterfaceOptions_AddCategory(panel)